use core::f64::consts;
use num_traits::float::Float;

pub fn distance_km(lat1: f64, lon1: f64, lat2: f64, lon2: f64) -> f64 {
    let r = 6371.0; // km
    let p = consts::PI / 180.0;

    let a = 0.5 - ((lat2 - lat1) * p).cos() / 2.0
        + (lat1 * p).cos() * (lat2 * p).cos() * (1.0 - ((lon2 - lon1) * p).cos()) / 2.0;

    2.0 * r * a.sqrt().asin()
}
